



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>pureMVC简单示例及其原理讲解三(View层)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">pureMVC简单示例及其原理讲解三(View层)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 17:25:15 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>本篇说的是View层，即视图层，在本示例中包括两个部分：MXML文件，即可视控件；Mediator。</p>
<h3>可视控件</h3>
<p>可视控件由UserForm.mxml（图1）和UserList.mxml（图2）两个文件组成。UserForm.mxml用于添加用户，UserList.mxml显示用户和删除已添加用户。</p>
<p><img referrerpolicy="no-referrer"src="http://superwulei.iteye.com/upload/picture/pic/46569/e1f0d6d2-0633-3e64-af43-9fdc9ae18c98.png" /></p>
<p>【图1】</p>
<p><img referrerpolicy="no-referrer"src="http://superwulei.iteye.com/upload/picture/pic/46571/bf0fb02c-804d-3bfb-b377-665e3c99a08b.png" /></p>
<p>【图2】</p>
<p>先看UserForm.mxml，既然要添加用户，就一定会要一个方法。你还记得么，在上一篇《<a href="http://superwulei.iteye.com/blog/484463" rel="external nofollow noreferrer">pureMVC简单示例及其原理讲解&mdash;&mdash;Model层</a>&nbsp;》中我们提到的UserProxy中有一个ArrayCollection类型的users属性和无返回值的addItem方法，其中users中存储UserVO，addItem方法用来向users中添加UserVO。现在我们既然要在界面通过添加按钮添加用户，我们必然要用到这个方法，但是我们不会在View层直接使用这个方法。因为pureMVC的追求是将MVC分离，而这些逻辑操作我们都会将其放入Command中，即Controller才层。但是在View层，我们也不是没有作为的。我先调一调你的胃口，不要着急，这个作为我们会在本篇接下来的部分讲。先看看userForm.mxml的代码。</p>
<div>
<ol><li>&lt;?xml&nbsp;version="1.0"&nbsp;encoding="utf-8"?&gt;</li>
<li>&lt;mx:Panel&nbsp;title="Registor"&nbsp;xmlns:mx="http://www.adobe.com/2006/mxml"&gt;</li>
<li>&lt;mx:Metadata&gt;</li>
<li>[Event('add')]</li>
<li>&lt;/mx:Metadata&gt;</li>
<li>&lt;mx:Script&gt;</li>
<li>&lt;![CDATA[</li>
<li>import&nbsp;mx.controls.Alert;</li>
<li>import&nbsp;com.superwulei.model.vo.UserVO;</li>
<li>public&nbsp;static&nbsp;const&nbsp;USER_ADD:String&nbsp;=&nbsp;"add";</li>
<li>public&nbsp;var&nbsp;user:UserVO;</li>
<li>/*&nbsp;添加用户&nbsp;*/</li>
<li>private&nbsp;function&nbsp;addUser():void&nbsp;{</li>
<li>user&nbsp;=&nbsp;new&nbsp;UserVO(email.text,&nbsp;password.text);</li>
<li>dispatchEvent(new&nbsp;Event(USER_ADD));</li>
<li>}</li>
<li>private&nbsp;function&nbsp;enableSubmit(u:String,&nbsp;p:String):Boolean&nbsp;{</li>
<li>return&nbsp;u&nbsp;!=&nbsp;''&nbsp;&amp;&amp;&nbsp;p&nbsp;!=&nbsp;'';</li>
<li>}</li>
<li>]]&gt;</li>
<li>&lt;/mx:Script&gt;</li>
<li>&lt;mx:Form&gt;</li>
<li>&lt;mx:FormItem&nbsp;label="email"&nbsp;required="true"&gt;</li>
<li>&lt;mx:TextInput&nbsp;id="email"/&gt;</li>
<li>&lt;/mx:FormItem&gt;</li>
<li>&lt;mx:FormItem&nbsp;label="password"&nbsp;required="true"&gt;</li>
<li>&lt;mx:TextInput&nbsp;id="password"&nbsp;displayAsPassword="true"/&gt;</li>
<li>&lt;/mx:FormItem&gt;</li>
<li>&lt;/mx:Form&gt;</li>
<li>&lt;mx:ControlBar&nbsp;horizontalAlign="right"&gt;</li>
<li>&lt;mx:Button&nbsp;id="sbumitButton"&nbsp;label="添加"</li>
<li>enabled="{enableSubmit(email.text,password.text)}"</li>
<li>click="addUser();"/&gt;</li>
<li>&lt;/mx:ControlBar&gt;</li>
<li>&lt;/mx:Panel&gt;</li></ol>
</div>
<p>在UserForm.mxml中定义一个Event，并对应的定义一个USER_ADD常量。来看看点击添加按钮后会怎么样？找到submitButton按钮的click事件对应的方法addUser。在addUser方法中，首先要生成一个UserVO对象user，这个user存储的信息就是你在界面上输入的email和密码；此外还要注意，这个UserVO的对象user事先已经声明，且是public的访问修饰符。之所以将user的访问限制设定为公有的，是由于这个user会在其他地方用到，这个其他地方请您关注。</p>
<p>一般的，一个可视控件会对应一个Mediator；但有时候多个可视控件也会对应一个Mediator。本示例中，可视控件和Mediator的关系是前者，即一对一。来看看UserForm.mxml对应的UserFormMediator.as代码。</p>
<div>
<ol><li>package&nbsp;com.superwulei.view</li>
<li>{</li>
<li>import&nbsp;com.superwulei.ApplicationFacade;</li>
<li>import&nbsp;com.superwulei.view.components.UserForm;</li>
<li>import&nbsp;flash.events.Event;</li>
<li>import&nbsp;org.puremvc.as3.patterns.mediator.Mediator;</li>
<li>public&nbsp;class&nbsp;UserFormMediator&nbsp;extends&nbsp;Mediator</li>
<li>{</li>
<li>public&nbsp;static&nbsp;const&nbsp;NAME:String&nbsp;=&nbsp;"UserFormMediator";</li>
<li>public&nbsp;function&nbsp;UserFormMediator(viewComponent:Object)</li>
<li>{</li>
<li>super(NAME,&nbsp;viewComponent);</li>
<li>userForm.addEventListener(UserForm.USER_ADD,onAdd);</li>
<li>}</li>
<li>private&nbsp;function&nbsp;get&nbsp;userForm():UserForm{</li>
<li>return&nbsp;viewComponent&nbsp;as&nbsp;UserForm;</li>
<li>}</li>
<li>/*&nbsp;添加用户监听器&nbsp;*/</li>
<li>private&nbsp;function&nbsp;onAdd(event:Event):void{</li>
<li>add();</li>
<li>}</li>
<li>/*&nbsp;添加用户方法&nbsp;*/</li>
<li>private&nbsp;function&nbsp;add():void{</li>
<li>sendNotification(ApplicationFacade.USER_ADDED,userForm.user);</li>
<li>}</li>
<li>}</li>
<li>}</li></ol>
</div>
<p>在View层，Mediator是pureMVC的核心，其私有变量viewComponent表示一个可视控件，上例中viewComponent表示UserForm，通过userForm属性实现。</p>
<p>看构造器UserFromMediator(...)。首先调用了父类的构造方法；然后给userForm属性加上onAdd监听器，这个userFrom属性是通过getter方法实现的，见get userForm():UserForm。来看onAdd监听器，调用add方法，在add方法中使用了sendNotification方法。刚才我们所说的添加用户的方法不是没有作为，这就是我所谓的有所作为，即&ldquo;发送通知&rdquo;。pureMVC中将逻辑控制放在了Controller层，因此在View层就不会有添加用户的代码，但是我们将&ldquo;添加用户&rdquo;这个命令以通知的方式发送出去。注意sendNotification方法中携带了两个参数，第一个参数是一个常量，第二个参数是一个UserVO对象。这个常量表示会调用与之对应的Command，这个UserVO对象表示的就是要添加的用户。这个在Controller层会讲到。</p>
<p>UserList.mxml和UserListMediator.as和上面的道理是类似的，在此不多言。以下是UserList.mxml和UserListMediator.as的代码。</p>
<div>
<ol><li>&lt;?xml&nbsp;version="1.0"&nbsp;encoding="utf-8"?&gt;</li>
<li>&lt;mx:Panel&nbsp;xmlns:mx="http://www.adobe.com/2006/mxml"&nbsp;title="已注册用户"&gt;</li>
<li>&lt;mx:Metadata&gt;</li>
<li>[Event('delete')]</li>
<li>&lt;/mx:Metadata&gt;</li>
<li>&lt;mx:DataGrid&nbsp;id="userGrid"&nbsp;dataProvider="{users}"&gt;</li>
<li>&lt;mx:Script&gt;</li>
<li>&lt;![CDATA[</li>
<li>import&nbsp;mx.formatters.DateFormatter;</li>
<li>import&nbsp;com.superwulei.model.vo.UserVO;</li>
<li>import&nbsp;mx.collections.ArrayCollection;</li>
<li>public&nbsp;static&nbsp;const&nbsp;USER_DELETE:String&nbsp;=&nbsp;"delete";</li>
<li>[Bindable]</li>
<li>public&nbsp;var&nbsp;users:ArrayCollection;</li>
<li>public&nbsp;var&nbsp;selectUser:UserVO;</li>
<li>private&nbsp;function&nbsp;deleteUser():void{</li>
<li>selectUser&nbsp;=&nbsp;userGrid.selectedItem&nbsp;as&nbsp;UserVO;</li>
<li>dispatchEvent(new&nbsp;Event(USER_DELETE));</li>
<li>}</li>
<li>]]&gt;</li>
<li>&lt;/mx:Script&gt;</li>
<li>&lt;mx:columns&gt;</li>
<li>&lt;mx:DataGridColumn&nbsp;dataField="email"/&gt;</li>
<li>&lt;mx:DataGridColumn&nbsp;dataField="password"/&gt;</li>
<li>&lt;mx:DataGridColumn&nbsp;dataField="regDate"&nbsp;width="200"/&gt;</li>
<li>&lt;/mx:columns&gt;</li>
<li>&lt;/mx:DataGrid&gt;</li>
<li>&lt;mx:HBox&nbsp;textAlign="center"&gt;</li>
<li>&lt;mx:Button&nbsp;id="deleteButton"&nbsp;label="删除"&nbsp;click="deleteUser();"/&gt;</li>
<li>&lt;/mx:HBox&gt;</li>
<li>&lt;/mx:Panel&gt;</li></ol>
</div>
<div>
<ol><li>package&nbsp;com.superwulei.view</li>
<li>{</li>
<li>import&nbsp;com.superwulei.ApplicationFacade;</li>
<li>import&nbsp;com.superwulei.model.UserProxy;</li>
<li>import&nbsp;com.superwulei.view.components.UserList;</li>
<li>import&nbsp;flash.events.Event;</li>
<li>import&nbsp;org.puremvc.as3.patterns.mediator.Mediator;</li>
<li>public&nbsp;class&nbsp;UserListMediator&nbsp;extends&nbsp;Mediator</li>
<li>{</li>
<li>private&nbsp;var&nbsp;userProxy:UserProxy;</li>
<li>public&nbsp;static&nbsp;const&nbsp;NAME:String&nbsp;=&nbsp;"UserListMediator";</li>
<li>public&nbsp;function&nbsp;UserListMediator(viewComponent:Object)</li>
<li>{</li>
<li>super(NAME,&nbsp;viewComponent);</li>
<li>userList.addEventListener(UserList.USER_DELETE,onDelete);</li>
<li>userProxy&nbsp;=&nbsp;facade.retrieveProxy(UserProxy.NAME)&nbsp;as&nbsp;UserProxy;</li>
<li>userList.users&nbsp;=&nbsp;userProxy.users;</li>
<li>}</li>
<li>private&nbsp;function&nbsp;get&nbsp;userList():UserList{</li>
<li>return&nbsp;viewComponent&nbsp;as&nbsp;UserList;</li>
<li>}</li>
<li>/*&nbsp;删除用户监听器&nbsp;*/</li>
<li>private&nbsp;function&nbsp;onDelete(event:Event):void{</li>
<li>deleteUser();</li>
<li>}</li>
<li>/*删除用户方法*/</li>
<li>private&nbsp;function&nbsp;deleteUser():void{</li>
<li>sendNotification(ApplicationFacade.USER_DELETE,userList.selectUser);</li>
<li>}</li>
<li>}</li>
<li>}</li></ol>
</div>
<p>关于Mediator再补充一下，在每个Mediator中会看到有一个公有的静态的常量字符串，这个字符串用来表示Mediator的类名。同样的在Proxy和Command中你也会看到，这样就可以通过facade的retrieveMediator、retrieveProxy和retieveCommand来检索对象。</p>
<p>关于Model层要记住：一个MXML可视控件对应一个Mediator，Mediator本身不处理操作但它会发送Notification（发送出去的Notification会自动被执行），关于界面上的操作采用监听的方式即addEventLisentner。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq16o28g.html">nodejs中使用http请求返回值为html时乱码问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn7ox8r.html">mysql substring函数截取值后赋给一个declare变量</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8opl5eq.html">MSComm32控件注册方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rl5dd9.html">FK JavaScript&colon;ArcGIS JavaScript类库加载不成功而导致的程序异常</a>
		</li>
						<li><a href="https://www.batexi.com/a/r935d2rq.html">代码风格与树形DP</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wn7dvq.html">log4j的使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd207z8.html">mongodb授权登录</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vgzd48.html">单线程Singleton模式的几个要点</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m4lwm8.html">201521123089 《Java程序设计》第9周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1k1ejq.html">解决 Docker Image的UTF-8中文字符集的问题&lpar;以Oracle为例&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9603v7j9.html">Java IO（三）&mdash;&mdash;字节流</a>
		</li>
						<li><a href="https://www.batexi.com/a/q252novq.html">shouldComponentUpdate 是做什么的，（react 性能优化是哪个周期函数？）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjr1749.html">面试回顾&mdash;&mdash;kafka</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o120mxq.html">【PAT】B1063 计算谱半径（20 分）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pkn03q.html">js实现点击按钮弹出上传文件的窗口</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjkxexq.html">Android-------------fragment的学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emrw6e9.html">流行创意风格教师求职简历免费word模板</a>
		</li>
						<li><a href="https://www.batexi.com/a/90dv5gj8.html">mysql字符集和校对规则&lpar;Mysql校对集&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8od0mzxq.html">&lowbar;&lowbar;bridge 使用注意</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7754pkq.html">&lbrack;Create&lowbar;Cdi&rsqb;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9ge41g78.html">Chapter 1 First Sight&mdash;&mdash;6</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdkdwz9.html">Coloring Trees</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkoky08.html">extJS4&period;2&period;0 Json数据解析&comma;嵌套及非嵌套（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zlz5x9.html">webpack&period;config&period;js 参数简单了解</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kprz69.html">Unity3d&sol;2d手机游戏开发第二版 &lpar;金玺曾&rpar; 随书资源</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojv161q.html">EF 报【序列包含一个以上的元素】解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mel25rq.html">Is it possible to run native sql with entity framework&quest;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey5mwz9.html">使用SQLServer2005插入一条数据时返回当前插入数据的ID</a>
			</li>
						<li><a href="https://www.batexi.com/a/950mmrz8.html">libconfig第二篇----两个小例子</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkoo7e8.html">使用for循环输出杨辉三角-还是不懂得需要复习</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
